From 0c3687aca9a84d5cf7c2b4264d6a21ef81421624 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Tue, 6 Dec 2016 18:23:17 -0700
Subject: [PATCH] Removed all references to 'xenroll.dll'.

PKI TRAC Ticket #2524 - Remove xenroll.dll from pki-core
---
 .../shared/webapps/ca/admin/ca/EnrollSuccess.template  |   7 -------
 .../webapps/ca/admin/ca/ImportAdminCert.template       |   4 ----
 base/ca/shared/webapps/ca/admin/ca/ImportCert.template |   8 --------
 base/ca/shared/webapps/ca/admin/ca/adminEnroll.html    |   7 -------
 .../shared/webapps/ca/agent/ca/EnrollSuccess.template  |   6 ------
 base/ca/shared/webapps/ca/agent/ca/ImportCert.template |  10 ----------
 .../webapps/ca/agent/ca/displayBySerial.template       |   6 ------
 base/ca/shared/webapps/ca/agent/xenroll.dll            | Bin 172664 -> 0 bytes
 base/ca/shared/webapps/ca/ee/ca/AIMEnroll.html         |   7 -------
 .../shared/webapps/ca/ee/ca/CertBasedDualEnroll.html   |   7 -------
 .../webapps/ca/ee/ca/CertBasedEncryptionEnroll.html    |   7 -------
 .../shared/webapps/ca/ee/ca/CertBasedSingleEnroll.html |   7 -------
 base/ca/shared/webapps/ca/ee/ca/DirPinUserEnroll.html  |   7 -------
 base/ca/shared/webapps/ca/ee/ca/DirUserEnroll.html     |   7 -------
 base/ca/shared/webapps/ca/ee/ca/EnrollSuccess.template |   7 -------
 .../shared/webapps/ca/ee/ca/ImportAdminCert.template   |   4 ----
 base/ca/shared/webapps/ca/ee/ca/ImportCert.template    |   8 --------
 base/ca/shared/webapps/ca/ee/ca/ManObjSignEnroll.html  |   7 -------
 base/ca/shared/webapps/ca/ee/ca/ManUserEnroll.html     |   7 -------
 base/ca/shared/webapps/ca/ee/ca/PortalEnrollment.html  |   7 -------
 base/ca/shared/webapps/ca/ee/ca/ProfileSelect.template |   2 --
 .../ca/shared/webapps/ca/ee/ca/RenewalSuccess.template |   6 ------
 .../shared/webapps/ca/ee/ca/displayBySerial.template   |   6 ------
 .../share/webapps/pki/admin/console/config/wizard.vm   |   5 -----
 24 files changed, 149 deletions(-)
 delete mode 100644 base/ca/shared/webapps/ca/agent/xenroll.dll

diff --git a/base/ca/shared/webapps/ca/admin/ca/EnrollSuccess.template b/base/ca/shared/webapps/ca/admin/ca/EnrollSuccess.template
index d370983..80c6332 100644
--- a/base/ca/shared/webapps/ca/admin/ca/EnrollSuccess.template
+++ b/base/ca/shared/webapps/ca/admin/ca/EnrollSuccess.template
@@ -186,12 +186,6 @@ if (navigator.appName == 'Netscape' &&
 
 </SCRIPT>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 '========================================================
@@ -236,7 +230,6 @@ if (navigator.appName == 'Netscape' &&
 	End Sub
 
 	ImportCertificate()
-
 </SCRIPT>
 
 </font>
diff --git a/base/ca/shared/webapps/ca/admin/ca/ImportAdminCert.template b/base/ca/shared/webapps/ca/admin/ca/ImportAdminCert.template
index e52764e..5d10154 100644
--- a/base/ca/shared/webapps/ca/admin/ca/ImportAdminCert.template
+++ b/base/ca/shared/webapps/ca/admin/ca/ImportAdminCert.template
@@ -21,10 +21,6 @@
 <TITLE>VBScript Administrator Certificate Enrollment
 </TITLE>
 <CMS_TEMPLATE>
-<OBJECT classid="clsid:127698E4-E730-4E5C-A2b1-21490A70C8A1"
-    codebase="xenroll.dll"
-    id=Enroll >
-</OBJECT>
 <SCRIPT language="VBScript">
 <!--
                 Dim pkcs7
diff --git a/base/ca/shared/webapps/ca/admin/ca/ImportCert.template b/base/ca/shared/webapps/ca/admin/ca/ImportCert.template
index 5530cf2..62299ec 100644
--- a/base/ca/shared/webapps/ca/admin/ca/ImportCert.template
+++ b/base/ca/shared/webapps/ca/admin/ca/ImportCert.template
@@ -135,12 +135,6 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 </SCRIPT>
 
 <!--
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <OBJECT id='g_objClassFactory' CLASSID='clsid:884e2049-217d-11da-b2a4-000e7bbb2b09'>
 </OBJECT>
 -->
@@ -150,8 +144,6 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 if (navigator.appName == "Microsoft Internet Explorer") {
   if ((navigator.appVersion).indexOf("NT 6.") > -1) {
     document.writeln("<OBJECT id='g_objClassFactory' CLASSID='clsid:884e2049-217d-11da-b2a4-000e7bbb2b09'></OBJECT>");
-  } else {
-    document.writeln("<OBJECT classid='clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1' CODEBASE='/xenroll.dll' id='Enroll'></OBJECT>");
   }
 }
 //-->
diff --git a/base/ca/shared/webapps/ca/admin/ca/adminEnroll.html b/base/ca/shared/webapps/ca/admin/ca/adminEnroll.html
index 8b6335a..a08d462 100644
--- a/base/ca/shared/webapps/ca/admin/ca/adminEnroll.html
+++ b/base/ca/shared/webapps/ca/admin/ca/adminEnroll.html
@@ -96,13 +96,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/agent/ca/EnrollSuccess.template b/base/ca/shared/webapps/ca/agent/ca/EnrollSuccess.template
index 08bcd52..44aecd1 100644
--- a/base/ca/shared/webapps/ca/agent/ca/EnrollSuccess.template
+++ b/base/ca/shared/webapps/ca/agent/ca/EnrollSuccess.template
@@ -160,12 +160,6 @@ if (navigator.appName == 'Netscape' &&
 
 </SCRIPT>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 '========================================================
diff --git a/base/ca/shared/webapps/ca/agent/ca/ImportCert.template b/base/ca/shared/webapps/ca/agent/ca/ImportCert.template
index 37ad258..46c4177 100644
--- a/base/ca/shared/webapps/ca/agent/ca/ImportCert.template
+++ b/base/ca/shared/webapps/ca/agent/ca/ImportCert.template
@@ -132,21 +132,11 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 //-->
 </SCRIPT>
 
-<!--
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
--->
-
 <SCRIPT LANGUAGE="JavaScript">
 //<!--
 if (navigator.appName == "Microsoft Internet Explorer") {
   if ((navigator.appVersion).indexOf("NT 6.") > -1) {
     document.writeln("<OBJECT id='g_objClassFactory' CLASSID='clsid:884e2049-217d-11da-b2a4-000e7bbb2b09'></OBJECT>");
-  } else {
-    document.writeln("<OBJECT classid='clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1' CODEBASE='/xenroll.dll' id='Enroll'></OBJECT>");
   }
 }
 //-->
diff --git a/base/ca/shared/webapps/ca/agent/ca/displayBySerial.template b/base/ca/shared/webapps/ca/agent/ca/displayBySerial.template
index e02fe30..0c7a904 100644
--- a/base/ca/shared/webapps/ca/agent/ca/displayBySerial.template
+++ b/base/ca/shared/webapps/ca/agent/ca/displayBySerial.template
@@ -214,12 +214,6 @@ if (result.header.noCertImport != null && result.header.noCertImport == false) {
 //-->
 </SCRIPT>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 '========================================================
diff --git a/base/ca/shared/webapps/ca/agent/xenroll.dll b/base/ca/shared/webapps/ca/agent/xenroll.dll
deleted file mode 100644
index 9375e988d20276d154a3ec4940588dc381bbb215..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/base/ca/shared/webapps/ca/ee/ca/AIMEnroll.html b/base/ca/shared/webapps/ca/ee/ca/AIMEnroll.html
index 79862b3..4b14a8b 100644
--- a/base/ca/shared/webapps/ca/ee/ca/AIMEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/AIMEnroll.html
@@ -26,13 +26,6 @@
 <SCRIPT LANGUAGE="JavaScript" SRC="/ca/ee/dynamicVars.js"> </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/ee/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/CertBasedDualEnroll.html b/base/ca/shared/webapps/ca/ee/ca/CertBasedDualEnroll.html
index 05d672f..9e37706 100644
--- a/base/ca/shared/webapps/ca/ee/ca/CertBasedDualEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/CertBasedDualEnroll.html
@@ -48,13 +48,6 @@ function validate(form)
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/ee/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/CertBasedEncryptionEnroll.html b/base/ca/shared/webapps/ca/ee/ca/CertBasedEncryptionEnroll.html
index 67cb0cb..466447c 100644
--- a/base/ca/shared/webapps/ca/ee/ca/CertBasedEncryptionEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/CertBasedEncryptionEnroll.html
@@ -105,13 +105,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/ee/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/CertBasedSingleEnroll.html b/base/ca/shared/webapps/ca/ee/ca/CertBasedSingleEnroll.html
index fe6910e..537d087 100644
--- a/base/ca/shared/webapps/ca/ee/ca/CertBasedSingleEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/CertBasedSingleEnroll.html
@@ -105,13 +105,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/ee/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/DirPinUserEnroll.html b/base/ca/shared/webapps/ca/ee/ca/DirPinUserEnroll.html
index 1c4ca22..b13b013 100644
--- a/base/ca/shared/webapps/ca/ee/ca/DirPinUserEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/DirPinUserEnroll.html
@@ -112,13 +112,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/DirUserEnroll.html b/base/ca/shared/webapps/ca/ee/ca/DirUserEnroll.html
index 703225a..28b1b3d 100644
--- a/base/ca/shared/webapps/ca/ee/ca/DirUserEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/DirUserEnroll.html
@@ -114,13 +114,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/EnrollSuccess.template b/base/ca/shared/webapps/ca/ee/ca/EnrollSuccess.template
index 771c6fb..d61c747 100644
--- a/base/ca/shared/webapps/ca/ee/ca/EnrollSuccess.template
+++ b/base/ca/shared/webapps/ca/ee/ca/EnrollSuccess.template
@@ -172,13 +172,6 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 //-->
 </SCRIPT>
 
-
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 '========================================================
diff --git a/base/ca/shared/webapps/ca/ee/ca/ImportAdminCert.template b/base/ca/shared/webapps/ca/ee/ca/ImportAdminCert.template
index e52764e..5d10154 100644
--- a/base/ca/shared/webapps/ca/ee/ca/ImportAdminCert.template
+++ b/base/ca/shared/webapps/ca/ee/ca/ImportAdminCert.template
@@ -21,10 +21,6 @@
 <TITLE>VBScript Administrator Certificate Enrollment
 </TITLE>
 <CMS_TEMPLATE>
-<OBJECT classid="clsid:127698E4-E730-4E5C-A2b1-21490A70C8A1"
-    codebase="xenroll.dll"
-    id=Enroll >
-</OBJECT>
 <SCRIPT language="VBScript">
 <!--
                 Dim pkcs7
diff --git a/base/ca/shared/webapps/ca/ee/ca/ImportCert.template b/base/ca/shared/webapps/ca/ee/ca/ImportCert.template
index 5530cf2..62299ec 100644
--- a/base/ca/shared/webapps/ca/ee/ca/ImportCert.template
+++ b/base/ca/shared/webapps/ca/ee/ca/ImportCert.template
@@ -135,12 +135,6 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 </SCRIPT>
 
 <!--
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <OBJECT id='g_objClassFactory' CLASSID='clsid:884e2049-217d-11da-b2a4-000e7bbb2b09'>
 </OBJECT>
 -->
@@ -150,8 +144,6 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 if (navigator.appName == "Microsoft Internet Explorer") {
   if ((navigator.appVersion).indexOf("NT 6.") > -1) {
     document.writeln("<OBJECT id='g_objClassFactory' CLASSID='clsid:884e2049-217d-11da-b2a4-000e7bbb2b09'></OBJECT>");
-  } else {
-    document.writeln("<OBJECT classid='clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1' CODEBASE='/xenroll.dll' id='Enroll'></OBJECT>");
   }
 }
 //-->
diff --git a/base/ca/shared/webapps/ca/ee/ca/ManObjSignEnroll.html b/base/ca/shared/webapps/ca/ee/ca/ManObjSignEnroll.html
index 9c2c86a..886a289 100644
--- a/base/ca/shared/webapps/ca/ee/ca/ManObjSignEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/ManObjSignEnroll.html
@@ -135,13 +135,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/ManUserEnroll.html b/base/ca/shared/webapps/ca/ee/ca/ManUserEnroll.html
index e552f8e..85ba59c 100644
--- a/base/ca/shared/webapps/ca/ee/ca/ManUserEnroll.html
+++ b/base/ca/shared/webapps/ca/ee/ca/ManUserEnroll.html
@@ -126,13 +126,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/PortalEnrollment.html b/base/ca/shared/webapps/ca/ee/ca/PortalEnrollment.html
index 8f3a373..b7e9009 100644
--- a/base/ca/shared/webapps/ca/ee/ca/PortalEnrollment.html
+++ b/base/ca/shared/webapps/ca/ee/ca/PortalEnrollment.html
@@ -132,13 +132,6 @@ function setCRMFRequest()
 </SCRIPT>
 </head>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 Function escapeDNComponent(comp)
diff --git a/base/ca/shared/webapps/ca/ee/ca/ProfileSelect.template b/base/ca/shared/webapps/ca/ee/ca/ProfileSelect.template
index a683867..591d3d7 100644
--- a/base/ca/shared/webapps/ca/ee/ca/ProfileSelect.template
+++ b/base/ca/shared/webapps/ca/ee/ca/ProfileSelect.template
@@ -526,8 +526,6 @@ function setCRMFRequest()
   if (isIE()) {
     if ((navigator.appVersion).indexOf("NT 6.") > -1) {
       document.writeln("<OBJECT id='g_objClassFactory' CLASSID='clsid:884e2049-217d-11da-b2a4-000e7bbb2b09'></OBJECT>");
-    } else {
-      document.writeln("<OBJECT classid='clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1' CODEBASE='/xenroll.dll' id='Enroll'></OBJECT>");
     }
     document.writeln('<form name="ReqForm" onSubmit="if (checkRequest()) {return true;} else {window.location.reload(); return false;}" method="post" action="' + uri + '">');
   } else if (typeof(crypto) != "undefined" && typeof(crypto.version) != "undefined") {
diff --git a/base/ca/shared/webapps/ca/ee/ca/RenewalSuccess.template b/base/ca/shared/webapps/ca/ee/ca/RenewalSuccess.template
index cb840d2..7346569 100644
--- a/base/ca/shared/webapps/ca/ee/ca/RenewalSuccess.template
+++ b/base/ca/shared/webapps/ca/ee/ca/RenewalSuccess.template
@@ -158,12 +158,6 @@ if (navigator.appName == 'Netscape' && (navMajorVersion() > 3) &&
 //-->
 </SCRIPT>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 '========================================================
diff --git a/base/ca/shared/webapps/ca/ee/ca/displayBySerial.template b/base/ca/shared/webapps/ca/ee/ca/displayBySerial.template
index 33bc45f..be65418 100644
--- a/base/ca/shared/webapps/ca/ee/ca/displayBySerial.template
+++ b/base/ca/shared/webapps/ca/ee/ca/displayBySerial.template
@@ -134,12 +134,6 @@ To import the certificate into your client, click the following button.
 </font>
 <p>
 
-<OBJECT
-	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1"
-	CODEBASE="/xenroll.dll"
-	id=Enroll    >
-</OBJECT>
-
 <SCRIPT LANGUAGE=VBS>
 <!--
 '========================================================
diff --git a/base/server/share/webapps/pki/admin/console/config/wizard.vm b/base/server/share/webapps/pki/admin/console/config/wizard.vm
index 41ed632..794421d 100644
--- a/base/server/share/webapps/pki/admin/console/config/wizard.vm
+++ b/base/server/share/webapps/pki/admin/console/config/wizard.vm
@@ -106,11 +106,6 @@ function process(fop) {
   <h1><img alt="" src="/pki/images/icon-software.gif" />
   $title </h1>
 
-<OBJECT classid="clsid:127698E4-E730-4E5C-A2b1-21490A70C8A1"
-    codebase="xenroll.dll"
-    id=Enroll >
-</OBJECT>
-
 <form name=f method=post action="wizard">
 <input type=hidden name=p value="$p">
 
-- 
2.9.3