From 442670633c1c79ffadb947fe547ef32a726bdbde Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 2 Nov 2012 15:20:07 -0400
Subject: [PATCH] Updated clearpixel.gif paths.

---
 base/ca/shared/conf/CS.cfg.in   | 6 +++---
 base/kra/shared/conf/CS.cfg.in  | 6 +++---
 base/ocsp/shared/conf/CS.cfg.in | 6 +++---
 base/ra/doc/CS.cfg.in           | 6 +++---
 base/tks/shared/conf/CS.cfg.in  | 6 +++---
 base/tps/doc/CS.cfg.in          | 6 +++---
 6 files changed, 18 insertions(+), 18 deletions(-)

diff --git a/base/ca/shared/conf/CS.cfg.in b/base/ca/shared/conf/CS.cfg.in
index 5a2eea6ca3b384469e5b8e645214c728ddb3a194..b0011783a0b390499e5699e9d477ebb5f0b7f166 100644
--- a/base/ca/shared/conf/CS.cfg.in
+++ b/base/ca/shared/conf/CS.cfg.in
@@ -129,13 +129,13 @@ preop.cert.admin.profile=adminCert.profile
 preop.hierarchy.profile=caCert.profile
 preop.configModules.module0.userFriendlyName=NSS Internal PKCS #11 Module
 preop.configModules.module0.commonName=NSS Internal PKCS #11 Module
-preop.configModules.module0.imagePath=../img/clearpixel.gif
+preop.configModules.module0.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module1.userFriendlyName=nCipher's nFast Token Hardware Module
 preop.configModules.module1.commonName=nfast
-preop.configModules.module1.imagePath=../img/clearpixel.gif
+preop.configModules.module1.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module2.userFriendlyName=SafeNet's LunaSA Token Hardware Module
 preop.configModules.module2.commonName=lunasa
-preop.configModules.module2.imagePath=../img/clearpixel.gif
+preop.configModules.module2.imagePath=/pki/images/clearpixel.gif
 preop.configModules.count=3
 preop.module.token=Internal Key Storage Token
 preop.name.caDN=CN=Certificate Authority
diff --git a/base/kra/shared/conf/CS.cfg.in b/base/kra/shared/conf/CS.cfg.in
index 087e40cb2ff9defcedc2404b5b8f98270fab51c3..126ea36843cecc3fc7afe5deda10c022c4e6068f 100644
--- a/base/kra/shared/conf/CS.cfg.in
+++ b/base/kra/shared/conf/CS.cfg.in
@@ -114,13 +114,13 @@ preop.cert.subsystem.cncomponent.override=true
 preop.hierarchy.profile=caCert.profile
 preop.configModules.module0.userFriendlyName=NSS Internal PKCS #11 Module
 preop.configModules.module0.commonName=NSS Internal PKCS #11 Module
-preop.configModules.module0.imagePath=../img/clearpixel.gif
+preop.configModules.module0.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module1.userFriendlyName=nCipher's nFast Token Hardware Module
 preop.configModules.module1.commonName=nfast
-preop.configModules.module1.imagePath=../img/clearpixel.gif
+preop.configModules.module1.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module2.userFriendlyName=SafeNet's LunaSA Token Hardware Module
 preop.configModules.module2.commonName=lunasa
-preop.configModules.module2.imagePath=../img/clearpixel.gif
+preop.configModules.module2.imagePath=/pki/images/clearpixel.gif
 preop.configModules.count=3
 preop.module.token=Internal Key Storage Token
 passwordFile=[PKI_INSTANCE_PATH]/conf/password.conf
diff --git a/base/ocsp/shared/conf/CS.cfg.in b/base/ocsp/shared/conf/CS.cfg.in
index 79448104ee3c641be5d2bcf49f56b38d3de3cec0..3a1e6c6606bca6ed92eb18bc387eee531f97ac75 100644
--- a/base/ocsp/shared/conf/CS.cfg.in
+++ b/base/ocsp/shared/conf/CS.cfg.in
@@ -32,13 +32,13 @@ proxy.securePort=[PKI_PROXY_SECURE_PORT]
 proxy.unsecurePort=[PKI_PROXY_UNSECURE_PORT]
 preop.configModules.module0.userFriendlyName=NSS Internal PKCS #11 Module
 preop.configModules.module0.commonName=NSS Internal PKCS #11 Module
-preop.configModules.module0.imagePath=../img/clearpixel.gif
+preop.configModules.module0.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module1.userFriendlyName=nCipher's nFast Token Hardware Module
 preop.configModules.module1.commonName=nfast
-preop.configModules.module1.imagePath=../img/clearpixel.gif
+preop.configModules.module1.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module2.userFriendlyName=SafeNet's LunaSA Token Hardware Module
 preop.configModules.module2.commonName=lunasa
-preop.configModules.module2.imagePath=../img/clearpixel.gif
+preop.configModules.module2.imagePath=/pki/images/clearpixel.gif
 preop.configModules.count=3
 preop.module.token=Internal Key Storage Token
 ocsp.cert.list=signing,sslserver,subsystem,audit_signing
diff --git a/base/ra/doc/CS.cfg.in b/base/ra/doc/CS.cfg.in
index 702dda90b18161c124f3ca912402bfa5dc0860dd..7e4b677f29a10b1ed4f544b445713cde4eed8fa7 100644
--- a/base/ra/doc/CS.cfg.in
+++ b/base/ra/doc/CS.cfg.in
@@ -224,13 +224,13 @@ preop.configModules._001=# Installation configuration "preop" module parameters
 preop.configModules._002=#########################################
 preop.configModules.count=3
 preop.configModules.module0.commonName=NSS Internal PKCS #11 Module
-preop.configModules.module0.imagePath=../img/clearpixel.gif
+preop.configModules.module0.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module0.userFriendlyName=NSS Internal PKCS #11 Module
 preop.configModules.module1.commonName=nfast
-preop.configModules.module1.imagePath=../img/clearpixel.gif
+preop.configModules.module1.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module1.userFriendlyName=nCipher's nFast Token Hardware Module
 preop.configModules.module2.commonName=lunasa
-preop.configModules.module2.imagePath=../img/clearpixel.gif
+preop.configModules.module2.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module2.userFriendlyName=SafeNet's LunaSA Token Hardware Module
 preop.module.token=NSS Certificate DB
 preop.keysize._000=#########################################
diff --git a/base/tks/shared/conf/CS.cfg.in b/base/tks/shared/conf/CS.cfg.in
index 7f11c4b18829c2f5f8360b705a7018c82e0fce26..da604d175eda632ef2917557a7fe90af90617031 100644
--- a/base/tks/shared/conf/CS.cfg.in
+++ b/base/tks/shared/conf/CS.cfg.in
@@ -79,13 +79,13 @@ preop.cert.admin.profile=adminCert.profile
 preop.hierarchy.profile=caCert.profile
 preop.configModules.module0.userFriendlyName=NSS Internal PKCS #11 Module
 preop.configModules.module0.commonName=NSS Internal PKCS #11 Module
-preop.configModules.module0.imagePath=../img/clearpixel.gif
+preop.configModules.module0.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module1.userFriendlyName=nCipher's nFast Token Hardware Module
 preop.configModules.module1.commonName=nfast
-preop.configModules.module1.imagePath=../img/clearpixel.gif
+preop.configModules.module1.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module2.userFriendlyName=SafeNet's LunaSA Token Hardware Module
 preop.configModules.module2.commonName=lunasa
-preop.configModules.module2.imagePath=../img/clearpixel.gif
+preop.configModules.module2.imagePath=/pki/images/clearpixel.gif
 preop.configModules.count=3
 preop.module.token=Internal Key Storage Token
 cs.state=0
diff --git a/base/tps/doc/CS.cfg.in b/base/tps/doc/CS.cfg.in
index 93e53fddeedf648b5f79dd54c2b5774f206c25fc..354cb5b9eb403f6a396ac8ec161763b165495fd3 100644
--- a/base/tps/doc/CS.cfg.in
+++ b/base/tps/doc/CS.cfg.in
@@ -411,13 +411,13 @@ preop.configModules._001=# Installation configuration "preop" module parameters
 preop.configModules._002=#########################################
 preop.configModules.count=3
 preop.configModules.module0.commonName=NSS Internal PKCS #11 Module
-preop.configModules.module0.imagePath=../img/clearpixel.gif
+preop.configModules.module0.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module0.userFriendlyName=NSS Internal PKCS #11 Module
 preop.configModules.module1.commonName=nfast
-preop.configModules.module1.imagePath=../img/clearpixel.gif
+preop.configModules.module1.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module1.userFriendlyName=nCipher's nFast Token Hardware Module
 preop.configModules.module2.commonName=lunasa
-preop.configModules.module2.imagePath=../img/clearpixel.gif
+preop.configModules.module2.imagePath=/pki/images/clearpixel.gif
 preop.configModules.module2.userFriendlyName=SafeNet's LunaSA Token Hardware Module
 preop.module.token=NSS Certificate DB
 preop.keysize._000=#########################################
-- 
1.7.12.1